Syncfusion AI Assistant

How can I help you?

Mention Support in EJ2 JavaScript Markdown Editor Control

22 Apr 202522 minutes to read

By integrating the Mention control with the Markdown Editor, users can effortlessly mention or tag other users or objects from a suggested list. This eliminates the need to manually type out names or identifying information, improving both efficiency and accuracy.

Enabling Mention in EJ2 JavaScript Markdown Editor

To enable the Mention functionality within the Markdown Editor, set the target property of the Mention control to the ID of the textarea element inside the editor. When specifying the target, ensure that you append the suffix _editable-content to the ID. This configuration allows users to mention or tag others from the suggested list while editing text.

When a user types the @ symbol followed by a character, the Markdown Editor displays a list of suggestions. Users can select an item from the list by either clicking on it or typing the desired name.

Configuring Mention Properties

The Syncfusion Mention control provides several customizable properties to enhance the tagging experience:

  • allowSpaces - Allow to continue search action if user enter space after mention character while searching.
  • suggestionCount - Defines the maximum number of items displayed in the suggestion list.
  • itemTemplate - Customizes the appearance of items in the suggestion list.

Example: Implementing Mention in Markdown Editor

The following example demonstrates how to enable Mention support in the Markdown Editor.

ej.base.enableRipple(true);

var textArea;
var mdsource;
var htmlPreview;

var markdownMention = new ej.richtexteditor.RichTextEditor({
  value: `Hello [@Maria](mailto:[email protected])\n\nWelcome to the mention integration with markdown editor demo. Type @ character and tag user from the suggestion list.`,
  height: 250,
  editorMode: 'Markdown',
  toolbarSettings: {
    items: [
      'Bold',
      'Italic',
      'StrikeThrough',
      '|',
      'Formats',
      'Blockquote',
      'OrderedList',
      'UnorderedList',
      'SuperScript',
      'SubScript',
      '|',
      'CreateLink',
      'Image',
      'CreateTable',
      '|',

      {
        tooltipText: 'Preview',
        template:
          '<button id="preview-code" class="e-tbar-btn e-control e-btn e-icon-btn"  aria-label="Preview Code">' +
          '<span class="e-btn-icon e-md-preview e-icons"></span></button>',
      },
      '|',
      'Undo',
      'Redo',
    ],
  },
  created: function () {
    textArea = markdownMention.contentModule.getEditPanel();
    textArea.addEventListener('keyup', function (e) {
      markdownConversion();
    });
    mdsource = document.getElementById('preview-code');
    mdsource.addEventListener('click', function (e) {
      fullPreview();
      if (e.currentTarget.classList.contains('e-active')) {
        markdownMention.disableToolbarItem([
          'Bold',
          'Italic',
          'StrikeThrough',
          'OrderedList',
          'UnorderedList',
          'SuperScript',
          'SubScript',
          'CreateLink',
          'Image',
          'CreateTable',
          'Formats',
          'Blockquote',
          'Undo',
          'Redo',
        ]);
      } else {
        markdownMention.enableToolbarItem([
          'Bold',
          'Italic',
          'StrikeThrough',
          'OrderedList',
          'UnorderedList',
          'SuperScript',
          'SubScript',
          'CreateLink',
          'Image',
          'CreateTable',
          'Formats',
          'Blockquote',
          'Undo',
          'Redo',
        ]);
      }
    });
  },
});
markdownMention.appendTo('#markdownMention');

var emailData = [
  {
    name: 'Selma Rose',
    initial: 'SR',
    email: '[email protected]',
    color: '#FAFDFF',
    bgColor: '#01579B',
  },
  {
    name: 'Maria',
    initial: 'MA',
    email: '[email protected]',
    color: '#004378',
    bgColor: '#ADDBFF',
  },
  {
    name: 'Russo Kay',
    initial: 'RK',
    email: '[email protected]',
    color: '#F9DEDC',
    bgColor: '#8C1D18',
  },
  {
    name: 'Robert',
    initial: 'RO',
    email: '[email protected]',
    color: '#FFD6F7',
    bgColor: '#37003A',
  },
  {
    name: 'Camden Kate',
    initial: 'CK',
    email: '[email protected]',
    color: '#FFFFFF',
    bgColor: '#464ECF',
  },
  {
    name: 'Garth',
    initial: 'GA',
    email: '[email protected]',
    color: '#FFFFFF',
    bgColor: '#008861',
  },
  {
    name: 'Andrew James',
    initial: 'AJ',
    email: '[email protected]',
    color: '#FFFFFF',
    bgColor: '#53CA17',
  },
  {
    name: 'Olivia',
    initial: 'OL',
    email: '[email protected]',
    color: '#FFFFFF',
    bgColor: '#8C1D18',
  },
  {
    name: 'Sophia',
    initial: 'SO',
    email: '[email protected]',
    color: '#000000',
    bgColor: '#D0BCFF',
  },
  {
    name: 'Margaret',
    initial: 'MA',
    email: '[email protected]',
    color: '#000000',
    bgColor: '#F2B8B5',
  },
  {
    name: 'Ursula Ann',
    initial: 'UA',
    email: '[email protected]',
    color: '#000000',
    bgColor: '#47ACFB',
  },
  {
    name: 'Laura Grace',
    initial: 'LG',
    email: '[email protected]',
    color: '#000000',
    bgColor: '#FFE088',
  },
  {
    name: 'Albert',
    initial: 'AL',
    email: '[email protected]',
    color: '#FFFFFF',
    bgColor: '#00335B',
  },
  {
    name: 'William',
    initial: 'WA',
    email: '[email protected]',
    color: '#FFFFFF',
    bgColor: '#163E02',
  },
];
var mention = new ej.dropdowns.Mention({
  dataSource: emailData,
  fields: { text: 'name' },
  displayTemplate: '[@${name}](mailto:${email})',
  itemTemplate:
    '<div class="editor-mention-item-template"><div class="em-header"><div class="em-avatar" style="background-color: ${bgColor}; color: ${color}"><div class="em-initial">${initial}</div></div></div><div class="em-content"><div class="em-name">${name}</div><div class="em-email">${email}</div></div></div>',
  popupWidth: '250px',
  popupHeight: '200px',
  sortOrder: 'Ascending',
  target: markdownMention.inputElement,
  allowSpaces: true,
});
mention.appendTo('#editorMention');

function markdownConversion() {
  if (mdsource.classList.contains('e-active')) {
    var id = markdownMention.getID() + 'html-view';
    var htmlPreview = document.body.querySelector(
      '#markdownMentionhtml-preview'
    );
    htmlPreview.innerHTML = marked(
      markdownMention.contentModule.getEditPanel().value
    );
  }
}
function fullPreview() {
  var id = markdownMention.getID() + 'html-preview';
  var htmlPreview = markdownMention.element.querySelector('#' + id);
  var previewTextArea = markdownMention.element.querySelector('.e-rte-content');
  if (mdsource.classList.contains('e-active')) {
    mdsource.classList.remove('e-active');
    mdsource.parentElement.title = 'Preview';
    textArea.style.display = 'block';
    htmlPreview.style.display = 'none';
    previewTextArea.style.overflow = 'hidden';
  } else {
    mdsource.classList.add('e-active');
    if (!htmlPreview) {
      htmlPreview = ej.base.createElement('div', {
        className: 'e-content e-pre-source',
      });
      htmlPreview.id = id;
      textArea.parentNode.appendChild(htmlPreview);
      previewTextArea.style.overflow = 'auto';
    }
    if (previewTextArea.style.overflow === 'hidden') {
      previewTextArea.style.overflow = 'auto';
    }
    textArea.style.display = 'none';
    htmlPreview.style.display = 'block';
    htmlPreview.innerHTML = marked(
      markdownMention.contentModule.getEditPanel().value
    );
    mdsource.parentElement.title = 'Code View';
  }
}

loadExternalFile();
// Dynamically load the marked.js file
function loadExternalFile() {
  var script = document.createElement('script');
  script.src = 'https://cdnjs.cloudflare.com/ajax/libs/marked/0.3.19/marked.js';
  document.getElementsByTagName('head')[0].appendChild(script);
}
<!DOCTYPE html><html lang="en"><head>
    <title>Essential JS 2 Rich Text Editor</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-richtexteditor/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-inputs/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-lists/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/tailwind3.css" rel="stylesheet">
     <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-dropdowns/styles/tailwind3.css" rel="stylesheet"/>
    
   
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="editorMention"></div>
        <div id="markdownMention"> 
    </div>
    <style>
        .e-richtexteditor textarea.e-content {
            float: left;
        }
        .e-richtexteditor .e-rte-content {
            overflow: hidden;
        }
        .e-icon-btn.e-active .e-md-preview::before {
            content: '\e350';
        }
        .e-icon-btn .e-md-preview::before {
            content: '\e345';
        }
            .bootstrap4 .e-icon-btn.e-active .e-md-preview::before {
            content: '\e790';
        }

        .bootstrap4 .e-icon-btn .e-md-preview::before {
            content: '\e787';
        }

        .tailwind .e-icon-btn.e-active .e-md-preview::before,
        .tailwind-dark .e-icon-btn.e-active .e-md-preview::before,
        .tailwind3 .e-icon-btn.e-active .e-md-preview::before,
        .tailwind3-dark .e-icon-btn.e-active .e-md-preview::before,
        .fluent .e-icon-btn.e-active .e-md-preview::before,
        .fluent-dark .e-icon-btn.e-active .e-md-preview::before,
        .fluent2 .e-icon-btn.e-active .e-md-preview::before,
        .fluent2-dark .e-icon-btn.e-active .e-md-preview::before,
        .fluent2-highcontrast .e-icon-btn.e-active .e-md-preview::before,
        .bootstrap5 .e-icon-btn.e-active .e-md-preview::before,
        .bootstrap5-dark .e-icon-btn.e-active .e-md-preview::before,
        .material3 .e-icon-btn.e-active .e-md-preview::before,
        .material3-dark .e-icon-btn.e-active .e-md-preview::before {
            content: '\e80e';
        }

        .tailwind .e-icon-btn .e-md-preview::before,
        .tailwind-dark .e-icon-btn .e-md-preview::before,
        .tailwind3 .e-icon-btn .e-md-preview::before,
        .tailwind3-dark .e-icon-btn .e-md-preview::before,
        .bootstrap5 .e-icon-btn .e-md-preview::before,
        .bootstrap5-dark .e-icon-btn .e-md-preview::before,
        .fluent .e-icon-btn .e-md-preview::before,
        .fluent-dark .e-icon-btn .e-md-preview::before,
        .fluent2 .e-icon-btn .e-md-preview::before,
        .fluent2-dark .e-icon-btn .e-md-preview::before,
        .fluent2-highcontrast .e-icon-btn .e-md-preview::before,
        .material3 .e-icon-btn .e-md-preview::before,
        .material3-dark .e-icon-btn .e-md-preview::before {
            content: '\e7de';
        }

        .editor-mention-item-template {
            width: 100%;
            height: 100%;
            display: flex;
            flex-direction: row;
            align-items: center;
        }

        .em-content {
            display: flex;
            flex-direction: column;
            justify-content: center;
        }

        .em-avatar {
            width: 32px;
            height: 32px;
            text-align: center;
            border-radius: 50%;
            font-size: 12px;
            font-weight: 500;
            text-indent: 0px;
            line-height: 13px;
            color: #fff;
            display: flex;
            align-items: center;
            justify-content: center;
        }

        .em-name {
            color: rgb(16, 24, 40);
            font-size: 14px;
            font-weight: 400;
            line-height: 14px;
            margin-bottom: 5px;
        }

        .em-email {
            color: gray;
            font-size: 12px;
            font-weight: 400;
            line-height: 14px;
        }

        #markdownMention_editable-content_popup li {
            padding: 10px;
            height: 60px;
        }

        body[class*="-dark"] .em-name {
            color: #fff !important;
        }

    </style>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Syncfusion AI Assistant

How can I help you?

Mention Support in React Markdown Editor Component

13 Apr 202624 minutes to read

By integrating the Mention component with the Markdown Editor, users can effortlessly mention or tag other users or objects from a suggested list. This eliminates the need to manually type out names or identifying information, improving both efficiency and accuracy.

Enabling mention in React Markdown Editor

To enable the Mention functionality within the Markdown Editor, set the target property of the Mention component to the ID of the textarea element inside the editor. When specifying the target, ensure that you append the suffix _editable-content to the ID. This configuration allows users to mention or tag others from the suggested list while editing text.

When a user types the @ symbol followed by a character, the Markdown Editor displays a list of suggestions. Users can select an item from the list by either clicking on it or typing the desired name.

Configuring mention properties

The Syncfusion Mention component provides several customizable properties to enhance the tagging experience:

  • allowSpaces - Allow to continue search action if user enter space after mention character while searching.
  • suggestionCount - Defines the maximum number of items displayed in the suggestion list.
  • itemTemplate - Customizes the appearance of items in the suggestion list.

Example: Implementing mention in markdown editor

The following example demonstrates how to enable Mention support in the React Markdown Editor.

[Class-component]

import { createElement } from '@syncfusion/ej2-base';
import { Image, Inject, Link, Table, MarkdownEditor, MarkdownFormatter, RichTextEditorComponent, Toolbar } from '@syncfusion/ej2-react-richtexteditor';
import * as React from 'react';
import * as Marked from 'marked';
import { MentionComponent } from '@syncfusion/ej2-react-dropdowns';

class App extends React.Component {
    rteObj;
    mention;
    value = 'Hello [@Maria](mailto:[email protected])\n\nWelcome to the mention integration with markdown editor demo. Type @ character and tag user from the suggestion list.';

    items = ['Bold', 'Italic', 'StrikeThrough', '|',
        'Formats', 'OrderedList', 'UnorderedList', '|',
        'CreateLink', 'Image', 'CreateTable',
        {
            tooltipText: 'Preview',
            template: '<button id="preview-code" class="e-tbar-btn e-control e-btn e-icon-btn" aria-label="Preview Code">' +
                '<span class="e-btn-icon e-md-preview e-icons"></span></button>'
        }, '|', 'Undo', 'Redo'];
    textArea;
    mdsource;
    emailData = [
        { name: "Selma Rose", initial: 'SR', email: "[email protected]", color: '#FAFDFF', bgColor: '#01579B' },
        { name: "Maria", initial: 'MA', email: "[email protected]", color: '#004378', bgColor: '#ADDBFF' },
        { name: "Russo Kay", initial: 'RK', email: "[email protected]", color: '#F9DEDC', bgColor: '#8C1D18' },
        { name: "Robert", initial: 'RO', email: "[email protected]", color: '#FFD6F7', bgColor: '#37003A' },
        { name: "Camden Kate", initial: 'CK', email: "[email protected]", color: '#FFFFFF', bgColor: '#464ECF' },
        { name: "Garth", initial: 'GA', email: "[email protected]", color: '#FFFFFF', bgColor: '#008861' },
        { name: "Andrew James", initial: 'AJ', email: "[email protected]", color: '#FFFFFF', bgColor: '#53CA17' },
        { name: "Olivia", initial: 'OL', email: "[email protected]", color: '#FFFFFF', bgColor: '#8C1D18' },
        { name: "Sophia", initial: 'SO', email: "[email protected]", color: '#000000', bgColor: '#D0BCFF' },
        { name: "Margaret", initial: 'MA', email: "[email protected]", color: '#000000', bgColor: '#F2B8B5' },
        { name: "Ursula Ann", initial: 'UA', email: "[email protected]", color: '#000000', bgColor: '#47ACFB' },
        { name: "Laura Grace", initial: 'LG', email: "[email protected]", color: '#000000', bgColor: '#FFE088' },
        { name: "Albert", initial: 'AL', email: "[email protected]", color: '#FFFFFF', bgColor: '#00335B' },
        { name: "William", initial: 'WA', email: "[email protected]", color: '#FFFFFF', bgColor: '#163E02' }
    ];

    toolbarSettings = {
        items: this.items
    };
    formatter = new MarkdownFormatter({ listTags: { 'OL': '1., 2., 3.' } });
    markdownConversion() {
        if (this.mdsource.classList.contains('e-active')) {
            let id = this.rteObj.getID() + 'html-view';
            let htmlPreview = this.rteObj.element.querySelector('#' + id);
            htmlPreview.innerHTML = Marked(this.rteObj.contentModule.getEditPanel().value);
        }
    }
    fullPreview() {
        let id = this.rteObj.getID() + 'html-preview';
        let htmlPreview = this.rteObj.element.querySelector('#' + id);
        if (this.mdsource.classList.contains('e-active')) {
            this.mdsource.classList.remove('e-active');
            this.mdsource.parentElement.title = 'Preview';
            this.textArea.style.display = 'block';
            htmlPreview.style.display = 'none';
        }
        else {
            this.mdsource.classList.add('e-active');
            if (!htmlPreview) {
                htmlPreview = createElement('div', { className: 'e-content e-pre-source' });
                htmlPreview.id = id;
                this.textArea.parentNode.appendChild(htmlPreview);
            }
            this.textArea.style.display = 'none';
            htmlPreview.style.display = 'block';
            htmlPreview.innerHTML = Marked(this.rteObj.contentModule.getEditPanel().value);
            this.mdsource.parentElement.title = 'Code View';
        }
    }
    rendereComplete() {
        if (!this.rteObj) {
            return;
        }
        this.textArea = this.rteObj.contentModule.getEditPanel();
        this.textArea.addEventListener('keyup', (e) => {
            this.markdownConversion();
        });
        this.mdsource = document.getElementById('preview-code');
        this.mdsource.addEventListener('click', (e) => {
            this.fullPreview();
            if (e.currentTarget.classList.contains('e-active')) {
                this.rteObj.disableToolbarItem(['Bold', 'Italic', 'StrikeThrough', '|',
                'Formats', 'OrderedList', 'UnorderedList', '|',
                'CreateLink', 'Image', 'CreateTable', 'Undo', 'Redo']);
            }
            else {
                this.rteObj.enableToolbarItem(['Bold', 'Italic', 'StrikeThrough', '|',
                'Formats', 'OrderedList', 'UnorderedList', '|',
                'CreateLink', 'Image', 'CreateTable', 'Undo', 'Redo']);
            }
        });
    }
    itemTemplate(data) {
        return (<div className="editor-mention-item-template">
            <div className="em-header">
              <div className="em-avatar" style=>
                <div className="em-initial">{data.initial}</div>
              </div>
            </div>
            <div className="em-content">
              <div className="em-name">{data.name}</div>
              <div className="em-email">{data.email}</div>
            </div>
          </div>);
    }
    displayTemplate(data) {
        return (<React.Fragment>
            [@{data.name}](mailto:${data.email})
            </React.Fragment>);
    }
    render() {
        return (
        <div className='control-section' id="rteMarkdown">
            <div className="content-wrapper">
                <RichTextEditorComponent id="markdownRTE" ref={(richtexteditor) => { this.rteObj = richtexteditor; }} created={this.rendereComplete} editorMode='Markdown' height='250px' value={this.value} formatter={this.formatter} toolbarSettings={this.toolbarSettings}>
                    <Inject services={[MarkdownEditor, Toolbar, Image, Link, Table]}/>
                </RichTextEditorComponent>
                <MentionComponent id='editorMention' ref={(mention) => { this.mention = mention; }} dataSource={this.emailData} displayTemplate={this.displayTemplate} itemTemplate={this.itemTemplate} target="#markdownRTE_editable-content" fields= popupWidth='250px' popupHeight='200px' sortOrder='Ascending' allowSpaces={true}></MentionComponent>
            </div>
        </div>);
    }
}
export default App;
import { createElement, KeyboardEventArgs } from '@syncfusion/ej2-base';
import { Image, Inject, Link, Table, MarkdownEditor, IToolbarItems, ToolbarSettingsModel, MarkdownFormatter, RichTextEditorComponent, Toolbar } from '@syncfusion/ej2-react-richtexteditor';
import * as React from 'react';
import * as Marked from 'marked';
import { MentionComponent } from '@syncfusion/ej2-react-dropdowns';

class App extends React.Component<{},{}> {
    private rteObj: RichTextEditorComponent;
    private mention: MentionComponent;

    // set the value to Rich Text Editor
    private value: string = 'Hello [@Maria](mailto:[email protected])\n\nWelcome to the mention integration with markdown editor demo. Type @ character and tag user from the suggestion list.';

    // Rich Text Editor items list
    private items: (string | IToolbarItems)[] = ['Bold', 'Italic', 'StrikeThrough', '|',
        'Formats', 'OrderedList', 'UnorderedList', 'SuperScript', 'SubScript', '|',
        'CreateLink', 'Image', 'CreateTable', '|',
        {
            tooltipText: 'Preview',
            template: '<button id="preview-code" class="e-tbar-btn e-control e-btn e-icon-btn" aria-label="Preview Code">' +
                '<span class="e-btn-icon e-md-preview e-icons"></span></button>'
        }, '|', 'Undo', 'Redo'];


    private textArea: HTMLTextAreaElement;
    private mdsource: HTMLElement;
    private mdPreview: HTMLElement;
    private emailData: { [key: string]: string; }[] = [
        { name: "Selma Rose", initial: 'SR', email: "[email protected]", color: '#FAFDFF', bgColor: '#01579B' },
        { name: "Maria", initial: 'MA', email: "[email protected]", color: '#004378', bgColor: '#ADDBFF' },
        { name: "Russo Kay", initial: 'RK', email: "[email protected]", color: '#F9DEDC', bgColor: '#8C1D18' },
        { name: "Robert", initial: 'RO', email: "[email protected]", color: '#FFD6F7', bgColor: '#37003A' },
        { name: "Camden Kate", initial: 'CK', email: "[email protected]", color: '#FFFFFF', bgColor: '#464ECF' },
        { name: "Garth", initial: 'GA', email: "[email protected]", color: '#FFFFFF', bgColor: '#008861' },
        { name: "Andrew James", initial: 'AJ', email: "[email protected]", color: '#FFFFFF', bgColor: '#53CA17' },
        { name: "Olivia", initial: 'OL', email: "[email protected]", color: '#FFFFFF', bgColor: '#8C1D18' },
        { name: "Sophia", initial: 'SO', email: "[email protected]", color: '#000000', bgColor: '#D0BCFF' },
        { name: "Margaret", initial: 'MA', email: "[email protected]", color: '#000000', bgColor: '#F2B8B5' },
        { name: "Ursula Ann", initial: 'UA', email: "[email protected]", color: '#000000', bgColor: '#47ACFB' },
        { name: "Laura Grace", initial: 'LG', email: "[email protected]", color: '#000000', bgColor: '#FFE088' },
        { name: "Albert", initial: 'AL', email: "[email protected]", color: '#FFFFFF', bgColor: '#00335B' },
        { name: "William", initial: 'WA', email: "[email protected]", color: '#FFFFFF', bgColor: '#163E02' }
      ];

    //Rich Text Editor ToolbarSettings
    private toolbarSettings: ToolbarSettingsModel = {
        items: this.items
    };

    private formatter: MarkdownFormatter = new MarkdownFormatter({ listTags: { 'OL': '1., 2., 3.' } });

    public markdownConversion() {
        if (this.mdsource.classList.contains('e-active')) {
            let id: string = this.rteObj.getID() + 'html-view';
            let htmlPreview: HTMLElement = this.rteObj.element.querySelector('#' + id);
            htmlPreview.innerHTML = Marked.marked((this.rteObj.contentModule.getEditPanel() as HTMLTextAreaElement).value);
        }
    }
    public fullPreview() {
        let id: string = this.rteObj.getID() + 'html-preview';
        let htmlPreview: HTMLElement = this.rteObj.element.querySelector('#' + id);
        if (this.mdsource.classList.contains('e-active')) {
            this.mdsource.classList.remove('e-active');
            this.mdsource.parentElement.title = 'Preview';
            this.textArea.style.display = 'block';
            htmlPreview.style.display = 'none';
        } else {
            this.mdsource.classList.add('e-active');
            if (!htmlPreview) {
                htmlPreview = createElement('div', { className: 'e-content e-pre-source' });
                htmlPreview.id = id;
                this.textArea.parentNode.appendChild(htmlPreview);
            }
            this.textArea.style.display = 'none';
            htmlPreview.style.display = 'block';
            htmlPreview.innerHTML = Marked.marked((this.rteObj.contentModule.getEditPanel() as HTMLTextAreaElement).value);
            this.mdsource.parentElement.title = 'Code View';
        }
    }
    public rendereComplete() {
        if (!this.rteObj) {
            return;
        }
        this.textArea = this.rteObj.contentModule.getEditPanel() as HTMLTextAreaElement;
        this.textArea.addEventListener('keyup', (e: KeyboardEventArgs) => {
            this.markdownConversion();
        });
        this.mdsource = document.getElementById('preview-code');
        this.mdsource.addEventListener('click', (e: MouseEvent) => {
            this.fullPreview();
            if ((e.currentTarget as HTMLElement).classList.contains('e-active')) {
                this.rteObj.disableToolbarItem(['Bold', 'Italic', 'StrikeThrough', 'OrderedList',
                    'UnorderedList', 'SuperScript', 'SubScript', 'CreateLink', 'Image', 'CreateTable', 'Formats', 'Undo', 'Redo']);
            } else {
                this.rteObj.enableToolbarItem(['Bold', 'Italic', 'StrikeThrough', 'OrderedList',
                    'UnorderedList', 'SuperScript', 'SubScript', 'CreateLink', 'Image', 'CreateTable', 'Formats', 'Undo', 'Redo']);
            }
        });
    }

    private itemTemplate(data: any) {
        return (
          <div className="editor-mention-item-template">
            <div className="em-header">
              <div className="em-avatar" style=>
                <div className="em-initial">{data.initial}</div>
              </div>
            </div>
            <div className="em-content">
              <div className="em-name">{data.name}</div>
              <div className="em-email">{data.email}</div>
            </div>
          </div>
        );
    }
    
    private displayTemplate(data: any){
        return (
            <React.Fragment>
            [@{data.name}](mailto:${data.email})
            </React.Fragment>
        );
    }
    public render() {
      return (
        <div className='control-section' id="rteMarkdown">
            <div className="content-wrapper">
                <RichTextEditorComponent id="markdownRTE"
                     ref={(richtexteditor) => { this.rteObj = richtexteditor }} editorMode='Markdown'
                    height='250px' value={this.value} formatter={this.formatter} toolbarSettings={this.toolbarSettings} created={this.rendereComplete} >
                    <Inject services={[MarkdownEditor, Toolbar, Image, Link, Table]} />
                </RichTextEditorComponent>
                <MentionComponent id='editorMention' ref={(mention: MentionComponent) => { this.mention = mention }} dataSource={this.emailData} displayTemplate={this.displayTemplate} itemTemplate={this.itemTemplate} target="#markdownRTE_editable-content" fields= popupWidth='250px' popupHeight='200px' sortOrder='Ascending' allowSpaces={true}></MentionComponent>
            </div>
        </div>
      );
    }
}
export default App;

[Functional-component]

import { createElement, KeyboardEventArgs } from '@syncfusion/ej2-base';
import { Image, Inject, Link, Table, MarkdownEditor, IToolbarItems, ToolbarSettingsModel, MarkdownFormatter, RichTextEditorComponent, Toolbar } from '@syncfusion/ej2-react-richtexteditor';
import * as React from 'react';
import * as Marked from 'marked';
import { MentionComponent } from '@syncfusion/ej2-react-dropdowns';

function App() {
    let rteObj;
    const value =
      'Hello [@Maria](mailto:[email protected])\n\nWelcome to the mention integration with markdown editor demo. Type @ character and tag user from the suggestion list.';
    const items = [
      'Bold', 'Italic', 'StrikeThrough', '|',
      'Formats', 'OrderedList', 'UnorderedList', '|',
      'CreateLink', 'Image', 'CreateTable',
      {
        tooltipText: 'Preview',
        template:
          '<button id="preview-code" class="e-tbar-btn e-control e-btn e-icon-btn" aria-label="Preview Code" >' +
          '<span class="e-btn-icon e-md-preview e-icons"></span></button>',
      },
      '|',
      'Undo',
      'Redo',
    ];
    let textArea;
    let mdsource;
    const emailData = [
      {
        name: 'Selma Rose',
        initial: 'SR',
        email: '[email protected]',
        color: '#FAFDFF',
        bgColor: '#01579B',
      },
      {
        name: 'Maria',
        initial: 'MA',
        email: '[email protected]',
        color: '#004378',
        bgColor: '#ADDBFF',
      },
      {
        name: 'Russo Kay',
        initial: 'RK',
        email: '[email protected]',
        color: '#F9DEDC',
        bgColor: '#8C1D18',
      },
      {
        name: 'Robert',
        initial: 'RO',
        email: '[email protected]',
        color: '#FFD6F7',
        bgColor: '#37003A',
      },
      {
        name: 'Camden Kate',
        initial: 'CK',
        email: '[email protected]',
        color: '#FFFFFF',
        bgColor: '#464ECF',
      },
      {
        name: 'Garth',
        initial: 'GA',
        email: '[email protected]',
        color: '#FFFFFF',
        bgColor: '#008861',
      },
      {
        name: 'Andrew James',
        initial: 'AJ',
        email: '[email protected]',
        color: '#FFFFFF',
        bgColor: '#53CA17',
      },
      {
        name: 'Olivia',
        initial: 'OL',
        email: '[email protected]',
        color: '#FFFFFF',
        bgColor: '#8C1D18',
      },
      {
        name: 'Sophia',
        initial: 'SO',
        email: '[email protected]',
        color: '#000000',
        bgColor: '#D0BCFF',
      },
      {
        name: 'Margaret',
        initial: 'MA',
        email: '[email protected]',
        color: '#000000',
        bgColor: '#F2B8B5',
      },
      {
        name: 'Ursula Ann',
        initial: 'UA',
        email: '[email protected]',
        color: '#000000',
        bgColor: '#47ACFB',
      },
      {
        name: 'Laura Grace',
        initial: 'LG',
        email: '[email protected]',
        color: '#000000',
        bgColor: '#FFE088',
      },
      {
        name: 'Albert',
        initial: 'AL',
        email: '[email protected]',
        color: '#FFFFFF',
        bgColor: '#00335B',
      },
      {
        name: 'William',
        initial: 'WA',
        email: '[email protected]',
        color: '#FFFFFF',
        bgColor: '#163E02',
      },
    ];
    const toolbarSettings = {
      items: items,
    };
    const formatter = new MarkdownFormatter({ listTags: { OL: '1., 2., 3.' } });
    function markdownConversion() {
      if (mdsource.classList.contains('e-active')) {
        let id = rteObj.getID() + 'html-view';
        let htmlPreview = rteObj.element.querySelector('#' + id);
        htmlPreview.innerHTML = Marked.marked(
          rteObj.contentModule.getEditPanel().value
        );
      }
    }
    function fullPreview() {
      let id = rteObj.getID() + 'html-preview';
      let htmlPreview = rteObj.element.querySelector('#' + id);
      if (mdsource.classList.contains('e-active')) {
        mdsource.classList.remove('e-active');
        mdsource.parentElement.title = 'Preview';
        textArea.style.display = 'block';
        htmlPreview.style.display = 'none';
      } else {
        mdsource.classList.add('e-active');
        if (!htmlPreview) {
          htmlPreview = createElement('div', {
            className: 'e-content e-pre-source',
          });
          htmlPreview.id = id;
          textArea.parentNode.appendChild(htmlPreview);
        }
        textArea.style.display = 'none';
        htmlPreview.style.display = 'block';
        htmlPreview.innerHTML = Marked.marked(
          rteObj.contentModule.getEditPanel().value
        );
        mdsource.parentElement.title = 'Code View';
      }
    }
    function rendereComplete() {
      textArea = rteObj.contentModule.getEditPanel();
      textArea.addEventListener('keyup', (e) => {
        markdownConversion();
      });
      mdsource = document.getElementById('preview-code');
      mdsource.addEventListener('click', (e) => {
        fullPreview();
        if (e.currentTarget.classList.contains('e-active')) {
          rteObj.disableToolbarItem([
            'Bold', 'Italic', 'StrikeThrough', '|',
                    'Formats', 'OrderedList', 'UnorderedList', '|',
                    'CreateLink', 'Image', 'CreateTable', 'Undo', 'Redo'
          ]);
        } else {
          rteObj.enableToolbarItem([
            'Bold', 'Italic', 'StrikeThrough', '|',
                    'Formats', 'OrderedList', 'UnorderedList', '|',
                    'CreateLink', 'Image', 'CreateTable', 'Undo', 'Redo'
          ]);
        }
      });
    }
    function itemTemplate(data) {
      return (
        <div className="editor-mention-item-template">
          <div className="em-header">
            <div
              className="em-avatar"
              style=
            >
              <div className="em-initial">{data.initial}</div>
            </div>
          </div>
          <div className="em-content">
            <div className="em-name">{data.name}</div>
            <div className="em-email">{data.email}</div>
          </div>
        </div>
      );
    }
    function displayTemplate(data) {
      return (
        <React.Fragment>
          [@{data.name}](mailto:${data.email})
        </React.Fragment>
      );
    }
    return (  <div className="control-section" id="rteMarkdown">
        <div className="content-wrapper">
          <RichTextEditorComponent
            id="markdownRTE"
            ref={(richtexteditor) => {
              rteObj = richtexteditor;
            }}
            editorMode="Markdown"
            height="250px"
            value={value}
            formatter={formatter}
            created={rendereComplete}
            toolbarSettings={toolbarSettings}
          >
            <Inject services={[MarkdownEditor, Toolbar, Image, Link, Table]} />
          </RichTextEditorComponent>
          <MentionComponent
            id="editorMention"
            ref={(mention) => {
              mention = mention;
            }}
            dataSource={emailData}
            displayTemplate={displayTemplate}
            itemTemplate={itemTemplate}
            target="#markdownRTE_editable-content"
            fields=
            popupWidth="250px"
            popupHeight="200px"
            sortOrder="Ascending"
            allowSpaces={true}
          ></MentionComponent>
        </div>
      </div>);
}
export default App;
import { createElement, KeyboardEventArgs } from '@syncfusion/ej2-base';
import { Image, Inject, Link, Table, MarkdownEditor, IToolbarItems, ToolbarSettingsModel, MarkdownFormatter, RichTextEditorComponent, Toolbar } from '@syncfusion/ej2-react-richtexteditor';
import * as React from 'react';
import * as Marked from 'marked';
import { MentionComponent } from '@syncfusion/ej2-react-dropdowns';

function App(){
    let rteObj: RichTextEditorComponent;

    const value: string = 'Hello [@Maria](mailto:[email protected])\n\nWelcome to the mention integration with markdown editor demo. Type @ character and tag user from the suggestion list.';

    const items: (string | IToolbarItems)[] = ['Bold', 'Italic', 'StrikeThrough', '|',
        'Formats', 'OrderedList', 'UnorderedList', '|',
        'CreateLink', 'Image', 'CreateTable',
        {
            tooltipText: 'Preview',
            template: '<button id="preview-code" class="e-tbar-btn e-control e-btn e-icon-btn" aria-label="Preview Code" >' +
                '<span class="e-btn-icon e-md-preview e-icons"></span></button>'
        }, '|', 'Undo', 'Redo'];


    let textArea: HTMLTextAreaElement;
    let mdsource: HTMLElement;
    const emailData: { [key: string]: string; }[] = [
        { name: "Selma Rose", initial: 'SR', email: "[email protected]", color: '#FAFDFF', bgColor: '#01579B' },
        { name: "Maria", initial: 'MA', email: "[email protected]", color: '#004378', bgColor: '#ADDBFF' },
        { name: "Russo Kay", initial: 'RK', email: "[email protected]", color: '#F9DEDC', bgColor: '#8C1D18' },
        { name: "Robert", initial: 'RO', email: "[email protected]", color: '#FFD6F7', bgColor: '#37003A' },
        { name: "Camden Kate", initial: 'CK', email: "[email protected]", color: '#FFFFFF', bgColor: '#464ECF' },
        { name: "Garth", initial: 'GA', email: "[email protected]", color: '#FFFFFF', bgColor: '#008861' },
        { name: "Andrew James", initial: 'AJ', email: "[email protected]", color: '#FFFFFF', bgColor: '#53CA17' },
        { name: "Olivia", initial: 'OL', email: "[email protected]", color: '#FFFFFF', bgColor: '#8C1D18' },
        { name: "Sophia", initial: 'SO', email: "[email protected]", color: '#000000', bgColor: '#D0BCFF' },
        { name: "Margaret", initial: 'MA', email: "[email protected]", color: '#000000', bgColor: '#F2B8B5' },
        { name: "Ursula Ann", initial: 'UA', email: "[email protected]", color: '#000000', bgColor: '#47ACFB' },
        { name: "Laura Grace", initial: 'LG', email: "[email protected]", color: '#000000', bgColor: '#FFE088' },
        { name: "Albert", initial: 'AL', email: "[email protected]", color: '#FFFFFF', bgColor: '#00335B' },
        { name: "William", initial: 'WA', email: "[email protected]", color: '#FFFFFF', bgColor: '#163E02' }
    ];
    const toolbarSettings: ToolbarSettingsModel = {
        items: items
    };

    const formatter: MarkdownFormatter = new MarkdownFormatter({ listTags: { 'OL': '1., 2., 3.' } });

    function markdownConversion(): void {
        if (mdsource.classList.contains('e-active')) {
            let id: string = rteObj.getID() + 'html-view';
            let htmlPreview: HTMLElement = rteObj.element.querySelector('#' + id);
            htmlPreview.innerHTML = Marked((rteObj.contentModule.getEditPanel() as HTMLTextAreaElement).value);
        }
    }
    function fullPreview(): void {
        let id: string = rteObj.getID() + 'html-preview';
        let htmlPreview: HTMLElement = rteObj.element.querySelector('#' + id);
        if (mdsource.classList.contains('e-active')) {
            mdsource.classList.remove('e-active');
            mdsource.parentElement.title = 'Preview';
            textArea.style.display = 'block';
            htmlPreview.style.display = 'none';
        } else {
            mdsource.classList.add('e-active');
            if (!htmlPreview) {
                htmlPreview = createElement('div', { className: 'e-content e-pre-source' });
                htmlPreview.id = id;
                textArea.parentNode.appendChild(htmlPreview);
            }
            textArea.style.display = 'none';
            htmlPreview.style.display = 'block';
            htmlPreview.innerHTML = Marked((rteObj.contentModule.getEditPanel() as HTMLTextAreaElement).value);
            mdsource.parentElement.title = 'Code View';
        }
    }
    function rendereComplete(): void {
        textArea = rteObj.contentModule.getEditPanel() as HTMLTextAreaElement;
        textArea.addEventListener('keyup', (e: KeyboardEventArgs) => {
            markdownConversion();
        });
        mdsource = document.getElementById('preview-code');
        mdsource.addEventListener('click', (e: MouseEvent) => {
            fullPreview();
            if ((e.currentTarget as HTMLElement).classList.contains('e-active')) {
                rteObj.disableToolbarItem(['Bold', 'Italic', 'StrikeThrough', '|',
                    'Formats', 'OrderedList', 'UnorderedList', '|',
                    'CreateLink', 'Image', 'CreateTable', 'Undo', 'Redo']);
            } else {
                rteObj.enableToolbarItem(['Bold', 'Italic', 'StrikeThrough', '|',
                    'Formats', 'OrderedList', 'UnorderedList', '|',
                    'CreateLink', 'Image', 'CreateTable', 'Undo', 'Redo']);
            }
        });
    }
    function itemTemplate(data: any): React.JSX.Element {
        return (
            <div className="editor-mention-item-template">
                <div className="em-header">
                    <div className="em-avatar" style=>
                        <div className="em-initial">{data.initial}</div>
                    </div>
                </div>
                <div className="em-content">
                    <div className="em-name">{data.name}</div>
                    <div className="em-email">{data.email}</div>
                </div>
            </div>
        );
    }

    function displayTemplate(data: any): React.JSX.Element {
        return (
        <React.Fragment>
        [@{data.name}](mailto:${data.email})
        </React.Fragment>
        );
    }

  return (
    <div className='control-section' id="rteMarkdown">
        <div className="content-wrapper">
            <RichTextEditorComponent id="markdownRTE"
                ref={(richtexteditor) => { rteObj = richtexteditor }} editorMode='Markdown'
                height='250px' value={value} formatter={formatter} created={rendereComplete} toolbarSettings={toolbarSettings} >
                <Inject services={[MarkdownEditor, Toolbar, Image, Link, Table]} />
            </RichTextEditorComponent>
            <MentionComponent id='editorMention' ref={(mention: MentionComponent) => { mention = mention }} dataSource={emailData} displayTemplate={displayTemplate} itemTemplate={itemTemplate} target="#markdownRTE_editable-content" fields= popupWidth='250px' popupHeight='200px' sortOrder='Ascending' allowSpaces={true}></MentionComponent>
        </div>
    </div>
  );
}

export default App;

Syncfusion AI Assistant

How can I help you?

Mention Support in Vue Markdown Editor Component

18 Mar 202524 minutes to read

By integrating the Mention component with the Markdown Editor, users can effortlessly mention or tag other users or objects from a suggested list. This eliminates the need to manually type out names or identifying information, improving both efficiency and accuracy.

Enabling Mention in Vue Markdown Editor

To enable the Mention functionality within the Markdown Editor, set the target property of the Mention component to the ID of the textarea element inside the editor. When specifying the target, ensure that you append the suffix _editable-content to the ID. This configuration allows users to mention or tag others from the suggested list while editing text.

When a user types the @ symbol followed by a character, the Markdown Editor displays a list of suggestions. Users can select an item from the list by either clicking on it or typing the desired name.

Configuring Mention Properties

The Syncfusion Mention component provides several customizable properties to enhance the tagging experience:

  • allowSpaces - Allow to continue search action if user enter space after mention character while searching.
  • suggestionCount - Defines the maximum number of items displayed in the suggestion list.
  • itemTemplate - Customizes the appearance of items in the suggestion list.

Example: Implementing Mention in Markdown Editor

The following example demonstrates how to enable Mention support in the Vue Markdown Editor.

<template>
  <div class="control-section rte-markdown-overview">
    <ejs-richtexteditor
      id="markdown-editor"
      ref="rteInstance"
      :toolbarSettings="toolbarSettings"
      :formatter="formatter"
      :created="created"
      :editorMode="editorMode"
      :height="height"
      :value="value"
    >
    </ejs-richtexteditor>
    <ejs-mention
      id="mention"
      ref="mentionObj"
      :target="target"
      :dataSource="emailData"
      :fields="mentionfields"
      allowSpaces="true"
      :itemTemplate="'iTemplate'"
      :displayTemplate="'dTemplate'"
      popupWidth="250px"
      popupHeight="200px"
    >
      <template v-slot:iTemplate="{ data }">
        <div class="editor-mention-item-template">
          <div class="em-header">
            <div
              class="em-avatar"
              :style="{
                'background-color': data.bgColor,
                color: data.color,
              }"
            >
              <div class="em-initial"></div>
            </div>
          </div>
          <div class="em-content">
            <div class="em-name"></div>
            <div class="em-email"></div>
          </div>
        </div>
      </template>
      <template v-slot:dTemplate="{ data }">
          [@](mailto:)
      </template>
    </ejs-mention>
  </div>
</template>

<style>
   .rte-markdown-overview .e-richtexteditor textarea.e-content {
  float: left;
}
.rte-markdown-overview .e-richtexteditor .e-rte-content {
  overflow: hidden;
}
.rte-markdown-overview .e-md-preview::before {
  content: '\e345';
}
.rte-markdown-overview .e-icon-btn.e-active .e-md-preview.e-icons::before {
  content: '\e350';
}
.bootstrap4 .rte-markdown-overview .e-icon-btn.e-active .e-md-preview::before {
  content: '\e790';
}
.bootstrap4 .rte-markdown-overview .e-icon-btn .e-md-preview::before {
  content: '\e787';
}
.fluent .rte-markdown-overview .e-icon-btn.e-active .e-md-preview::before,
.fluent-dark .rte-markdown-overview .e-icon-btn.e-active .e-md-preview::before,
.fluent2 .rte-markdown-overview .e-icon-btn.e-active .e-md-preview::before,
.fluent2-dark .rte-markdown-overview .e-icon-btn.e-active .e-md-preview::before,
.fluent2-highcontrast
  .rte-markdown-overview
  .e-icon-btn.e-active
  .e-md-preview::before,
.tailwind .rte-markdown-overview .e-icon-btn.e-active .e-md-preview::before,
.tailwind-dark
  .rte-markdown-overview
  .e-icon-btn.e-active
  .e-md-preview::before,
.tailwind3 .rte-markdown-overview .e-icon-btn.e-active .e-md-preview::before,
.tailwind3-dark
  .rte-markdown-overview
  .e-icon-btn.e-active
  .e-md-preview::before,
.bootstrap5 .rte-markdown-overview .e-icon-btn.e-active .e-md-preview::before,
.bootstrap5\.3
  .rte-markdown-overview
  .e-icon-btn.e-active
  .e-md-preview::before,
.bootstrap5\.3-dark
  .rte-markdown-overview
  .e-icon-btn.e-active
  .e-md-preview::before,
.bootstrap5-dark
  .rte-markdown-overview
  .e-icon-btn.e-active
  .e-md-preview::before,
.material3 .rte-markdown-overview .e-icon-btn.e-active .e-md-preview::before,
.material3-dark
  .rte-markdown-overview
  .e-icon-btn.e-active
  .e-md-preview::before {
  content: '\e80e';
}
.tailwind .rte-markdown-overview .e-icon-btn .e-md-preview::before,
.tailwind-dark .rte-markdown-overview .e-icon-btn .e-md-preview::before,
.tailwind3 .rte-markdown-overview .e-icon-btn .e-md-preview::before,
.tailwind3-dark .rte-markdown-overview .e-icon-btn .e-md-preview::before,
.bootstrap5 .rte-markdown-overview .e-icon-btn .e-md-preview::before,
.bootstrap5\.3 .rte-markdown-overview .e-icon-btn .e-md-preview::before,
.bootstrap5\.3-dark .rte-markdown-overview .e-icon-btn .e-md-preview::before,
.bootstrap5-dark .rte-markdown-overview .e-icon-btn .e-md-preview::before,
.fluent .rte-markdown-overview .e-icon-btn .e-md-preview::before,
.fluent-dark .rte-markdown-overview .e-icon-btn .e-md-preview::before,
.fluent2 .rte-markdown-overview .e-icon-btn .e-md-preview::before,
.fluent2-dark .rte-markdown-overview .e-icon-btn .e-md-preview::before,
.fluent2-highcontrast .rte-markdown-overview .e-icon-btn .e-md-preview::before,
.material3 .rte-markdown-overview .e-icon-btn .e-md-preview::before,
.material3-dark .rte-markdown-overview .e-icon-btn .e-md-preview::before {
  content: '\e7de';
}
/** Mention template styles **/
.editor-mention-item-template {
  width: 100%;
  height: 100%;
  display: flex;
  flex-direction: row;
  align-items: center;
}

.em-content {
  display: flex;
  flex-direction: column;
  justify-content: center;
}

.em-avatar {
  width: 32px;
  height: 32px;
  text-align: center;
  border-radius: 50%;
  font-size: 12px;
  font-weight: 500;
  text-indent: 0px;
  line-height: 13px;
  color: #fff;
  display: flex;
  align-items: center;
  justify-content: center;
}

.em-name {
  color: rgb(16, 24, 40);
  font-size: 14px;
  font-weight: 400;
  line-height: 14px;
  margin-bottom: 5px;
}

.em-email {
  color: gray;
  font-size: 12px;
  font-weight: 400;
  line-height: 14px;
}

#markdown-editor_editable-content_popup li {
  padding: 10px !important;
  height: 60px;
}

body[class*='-dark'] .em-name {
  color: #fff !important;
}
</style>

<script setup>
import {
  RichTextEditorComponent,
  Toolbar,
  Link,
  Image,
  MarkdownEditor,
  Table,
} from '@syncfusion/ej2-vue-richtexteditor';
import { MarkdownFormatter } from '@syncfusion/ej2-vue-richtexteditor';
import { MentionComponent } from '@syncfusion/ej2-vue-dropdowns';
import { marked } from 'marked';

const formatter = new MarkdownFormatter({ listTags: { OL: '1., 2., 3.' } });
const rteInstance = ref(null);
let id= ''
let mdsource= null;
let htmlPreview= null;
let textArea= null;
let previewTextArea= null;
const height= '250px';
const editorMode = 'Markdown';
const value=
            `Hello [@Maria](mailto:[email protected])\n\nWelcome to the mention integration with markdown editor demo. Type @ character and tag user from the suggestion list.`;
const target= "#markdown-editor_editable-content";
const mentionfields= { text: 'name' };

const toolbarSettings = {
    items: [
        'Bold',
        'Italic',
        'StrikeThrough',
        '|',
        'Formats',
        'Blockquote',
        'OrderedList',
        'UnorderedList',
        'SuperScript',
        'SubScript',
        '|',
        'CreateLink',
        'Image',
        'CreateTable',
        '|',
        {
        tooltipText: 'Preview',
        template:
            '<button id="preview-code" class="e-tbar-btn e-control e-btn e-icon-btn" aria-label="Preview Code">' +
            '<span class="e-btn-icon e-md-preview e-icons"></span></button>',
        },
        '|',
        'Undo',
        'Redo',
    ],
};

const emailData= [
    {
      name: 'Selma Rose',
      initial: 'SR',
      email: '[email protected]',
      color: '#FAFDFF',
      bgColor: '#01579B',
    },
    {
      name: 'Maria',
      initial: 'MA',
      email: '[email protected]',
      color: '#004378',
      bgColor: '#ADDBFF',
    },
    {
      name: 'Russo Kay',
      initial: 'RK',
      email: '[email protected]',
      color: '#F9DEDC',
      bgColor: '#8C1D18',
    },
    {
      name: 'Robert',
      initial: 'RO',
      email: '[email protected]',
      color: '#FFD6F7',
      bgColor: '#37003A',
    },
    {
      name: 'Camden Kate',
      initial: 'CK',
      email: '[email protected]',
      color: '#FFFFFF',
      bgColor: '#464ECF',
    },
    {
      name: 'Garth',
      initial: 'GA',
      email: '[email protected]',
      color: '#FFFFFF',
      bgColor: '#008861',
    },
    {
      name: 'Andrew James',
      initial: 'AJ',
      email: '[email protected]',
      color: '#FFFFFF',
      bgColor: '#53CA17',
    },
    {
      name: 'Olivia',
      initial: 'OL',
      email: '[email protected]',
      color: '#FFFFFF',
      bgColor: '#8C1D18',
    },
    {
      name: 'Sophia',
      initial: 'SO',
      email: '[email protected]',
      color: '#000000',
      bgColor: '#D0BCFF',
    },
    {
      name: 'Margaret',
      initial: 'MA',
      email: '[email protected]',
      color: '#000000',
      bgColor: '#F2B8B5',
    },
    {
      name: 'Ursula Ann',
      initial: 'UA',
      email: '[email protected]',
      color: '#000000',
      bgColor: '#47ACFB',
    },
    {
      name: 'Laura Grace',
      initial: 'LG',
      email: '[email protected]',
      color: '#000000',
      bgColor: '#FFE088',
    },
    {
      name: 'Albert',
      initial: 'AL',
      email: '[email protected]',
      color: '#FFFFFF',
      bgColor: '#00335B',
    },
    {
      name: 'William',
      initial: 'WA',
      email: '[email protected]',
      color: '#FFFFFF',
      bgColor: '#163E02',
    },
];

const created = () => {
    this.rteObj = this.$refs.rteInstance.ej2Instances;
    this.textArea = this.rteObj.contentModule.getEditPanel();
    this.id = this.$refs.rteInstance.ej2Instances.getID() + 'html-preview';
    this.mdsource = document.getElementById('preview-code');
    this.htmlPreview = this.rteObj.element.querySelector(this.id);
    this.previewTextArea =
        this.rteObj.element.querySelector('.e-rte-content');
    this.textArea.onkeyup = (Event) => {
        this.markDownConversion();
    };
    this.mdsource.onclick = (e) => {
        this.fullPreview();
        if (e.currentTarget.classList.contains('e-active')) {
        this.$refs.rteInstance.disableToolbarItem(['CreateTable']);
        } else {
        this.$refs.rteInstance.enableToolbarItem(['CreateTable']);
        }
    };
};
const markDownConversion = () => {
    if (this.mdsource.classList.contains('e-active')) {
        this.htmlPreview.innerHTML = marked(this.textArea.value);
    }
};
const fullPreview = (event) => {
    if (this.mdsource.classList.contains('e-active')) {
        this.mdsource.classList.remove('e-active');
        this.textArea.style.display = 'block';
        this.htmlPreview.style.display = 'none';
        this.previewTextArea.style.overflow = 'hidden';
    } else {
        this.mdsource.classList.add('e-active');
        if (!this.htmlPreview) {
        this.htmlPreview = document.createElement('div');
        this.htmlPreview.setAttribute('class', 'e-content e-pre-source');
        this.htmlPreview.setAttribute('id', this.id);
        this.textArea.parentNode.appendChild(this.htmlPreview);
        this.previewTextArea.style.overflow = 'auto';
        }
        if (this.previewTextArea.style.overflow === 'hidden') {
        this.previewTextArea.style.overflow = 'auto';
        }
        this.textArea.style.display = 'none';
        this.htmlPreview.style.display = 'block';
        this.htmlPreview.innerHTML = marked(this.textArea.value);
        this.mdsource.parentElement.title = 'Code View';
    }
}
provide('richtexteditor', [Toolbar, Link, Image, Table, MarkdownEditor]);
</script>

<style>
@import "../../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-inputs/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-lists/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-buttons/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-vue-richtexteditor/styles/tailwind3.css";
</style>
<template>
  <div class="control-section rte-markdown-overview">
    <ejs-richtexteditor
      id="markdown-editor"
      ref="rteInstance"
      :toolbarSettings="toolbarSettings"
      :created="created"
      :editorMode="editorMode"
      :height="height"
      :value="value"
    >
    </ejs-richtexteditor>
    <ejs-mention
      id="mention"
      ref="mentionObj"
      :target="target"
      :dataSource="emailData"
      :fields="mentionfields"
      allowSpaces="true"
      :itemTemplate="'iTemplate'"
      :displayTemplate="'dTemplate'"
      popupWidth="250px"
      popupHeight="200px"
    >
      <template v-slot:iTemplate="{ data }">
        <div class="editor-mention-item-template">
          <div class="em-header">
            <div
              class="em-avatar"
              :style="{
                'background-color': data.bgColor,
                color: data.color,
              }"
            >
              <div class="em-initial"></div>
            </div>
          </div>
          <div class="em-content">
            <div class="em-name"></div>
            <div class="em-email"></div>
          </div>
        </div>
      </template>
      <template v-slot:dTemplate="{ data }">
        [@](mailto:)
      </template>
    </ejs-mention>
  </div>
</template>

<style>
.rte-markdown-overview .e-richtexteditor textarea.e-content {
  float: left;
}
.rte-markdown-overview .e-richtexteditor .e-rte-content {
  overflow: hidden;
}
.rte-markdown-overview .e-md-preview::before {
  content: '\e345';
}
.rte-markdown-overview .e-icon-btn.e-active .e-md-preview.e-icons::before {
  content: '\e350';
}
.bootstrap4 .rte-markdown-overview .e-icon-btn.e-active .e-md-preview::before {
  content: '\e790';
}
.bootstrap4 .rte-markdown-overview .e-icon-btn .e-md-preview::before {
  content: '\e787';
}
.fluent .rte-markdown-overview .e-icon-btn.e-active .e-md-preview::before,
.fluent-dark .rte-markdown-overview .e-icon-btn.e-active .e-md-preview::before,
.fluent2 .rte-markdown-overview .e-icon-btn.e-active .e-md-preview::before,
.fluent2-dark .rte-markdown-overview .e-icon-btn.e-active .e-md-preview::before,
.fluent2-highcontrast
  .rte-markdown-overview
  .e-icon-btn.e-active
  .e-md-preview::before,
.tailwind .rte-markdown-overview .e-icon-btn.e-active .e-md-preview::before,
.tailwind-dark
  .rte-markdown-overview
  .e-icon-btn.e-active
  .e-md-preview::before,
.tailwind3 .rte-markdown-overview .e-icon-btn.e-active .e-md-preview::before,
.tailwind3-dark
  .rte-markdown-overview
  .e-icon-btn.e-active
  .e-md-preview::before,
.bootstrap5 .rte-markdown-overview .e-icon-btn.e-active .e-md-preview::before,
.bootstrap5\.3
  .rte-markdown-overview
  .e-icon-btn.e-active
  .e-md-preview::before,
.bootstrap5\.3-dark
  .rte-markdown-overview
  .e-icon-btn.e-active
  .e-md-preview::before,
.bootstrap5-dark
  .rte-markdown-overview
  .e-icon-btn.e-active
  .e-md-preview::before,
.material3 .rte-markdown-overview .e-icon-btn.e-active .e-md-preview::before,
.material3-dark
  .rte-markdown-overview
  .e-icon-btn.e-active
  .e-md-preview::before {
  content: '\e80e';
}
.tailwind .rte-markdown-overview .e-icon-btn .e-md-preview::before,
.tailwind-dark .rte-markdown-overview .e-icon-btn .e-md-preview::before,
.tailwind3 .rte-markdown-overview .e-icon-btn .e-md-preview::before,
.tailwind3-dark .rte-markdown-overview .e-icon-btn .e-md-preview::before,
.bootstrap5 .rte-markdown-overview .e-icon-btn .e-md-preview::before,
.bootstrap5\.3 .rte-markdown-overview .e-icon-btn .e-md-preview::before,
.bootstrap5\.3-dark .rte-markdown-overview .e-icon-btn .e-md-preview::before,
.bootstrap5-dark .rte-markdown-overview .e-icon-btn .e-md-preview::before,
.fluent .rte-markdown-overview .e-icon-btn .e-md-preview::before,
.fluent-dark .rte-markdown-overview .e-icon-btn .e-md-preview::before,
.fluent2 .rte-markdown-overview .e-icon-btn .e-md-preview::before,
.fluent2-dark .rte-markdown-overview .e-icon-btn .e-md-preview::before,
.fluent2-highcontrast .rte-markdown-overview .e-icon-btn .e-md-preview::before,
.material3 .rte-markdown-overview .e-icon-btn .e-md-preview::before,
.material3-dark .rte-markdown-overview .e-icon-btn .e-md-preview::before {
  content: '\e7de';
}
/** Mention template styles **/
.editor-mention-item-template {
  width: 100%;
  height: 100%;
  display: flex;
  flex-direction: row;
  align-items: center;
}

.em-content {
  display: flex;
  flex-direction: column;
  justify-content: center;
}

.em-avatar {
  width: 32px;
  height: 32px;
  text-align: center;
  border-radius: 50%;
  font-size: 12px;
  font-weight: 500;
  text-indent: 0px;
  line-height: 13px;
  color: #fff;
  display: flex;
  align-items: center;
  justify-content: center;
}

.em-name {
  color: rgb(16, 24, 40);
  font-size: 14px;
  font-weight: 400;
  line-height: 14px;
  margin-bottom: 5px;
}

.em-email {
  color: gray;
  font-size: 12px;
  font-weight: 400;
  line-height: 14px;
}

#markdown-editor_editable-content_popup li {
  padding: 10px !important;
  height: 60px;
}

body[class*='-dark'] .em-name {
  color: #fff !important;
}
</style>

<script>
import {
  RichTextEditorComponent,
  Toolbar,
  Link,
  Image,
  MarkdownEditor,
  Table,
} from '@syncfusion/ej2-vue-richtexteditor';
import { MarkdownFormatter } from '@syncfusion/ej2-vue-richtexteditor';
import { MentionComponent } from '@syncfusion/ej2-vue-dropdowns';
import { marked } from 'marked';

export default {
    name: "App",
    components: {
        'ejs-richtexteditor': RichTextEditorComponent,
        'ejs-mention': MentionComponent,
    },
    data: function() {
         return {
          id: '',
          mdsource: null,
          htmlPreview: null,
          textArea: null,
          previewTextArea: null,
          height: '250px',
          editorMode: 'Markdown',
          value:
            'Hello [@Maria](mailto:[email protected])\n\nWelcome to the mention integration with markdown editor demo. Type @ character and tag user from the suggestion list.',
          target: '#markdown-editor_editable-content',
          mentionfields: { text: 'name' },
          placeholder: 'Enter your text here...',
          toolbarSettings: {
            items: [
              'Bold',
              'Italic',
              'StrikeThrough',
              '|',
              'Formats',
              'Blockquote',
              'OrderedList',
              'UnorderedList',
              'SuperScript',
              'SubScript',
              '|',
              'CreateLink',
              'Image',
              'CreateTable',
              '|',
              {
                tooltipText: 'Preview',
                template:
                  '<button id="preview-code" class="e-tbar-btn e-control e-btn e-icon-btn" aria-label="Preview Code">' +
                  '<span class="e-btn-icon e-md-preview e-icons"></span></button>',
              },
              '|',
              'Undo',
              'Redo',
            ],
          },
          emailData: [
            {
              name: 'Selma Rose',
              initial: 'SR',
              email: '[email protected]',
              color: '#FAFDFF',
              bgColor: '#01579B',
            },
            {
              name: 'Maria',
              initial: 'MA',
              email: '[email protected]',
              color: '#004378',
              bgColor: '#ADDBFF',
            },
            {
              name: 'Russo Kay',
              initial: 'RK',
              email: '[email protected]',
              color: '#F9DEDC',
              bgColor: '#8C1D18',
            },
            {
              name: 'Robert',
              initial: 'RO',
              email: '[email protected]',
              color: '#FFD6F7',
              bgColor: '#37003A',
            },
            {
              name: 'Camden Kate',
              initial: 'CK',
              email: '[email protected]',
              color: '#FFFFFF',
              bgColor: '#464ECF',
            },
            {
              name: 'Garth',
              initial: 'GA',
              email: '[email protected]',
              color: '#FFFFFF',
              bgColor: '#008861',
            },
            {
              name: 'Andrew James',
              initial: 'AJ',
              email: '[email protected]',
              color: '#FFFFFF',
              bgColor: '#53CA17',
            },
            {
              name: 'Olivia',
              initial: 'OL',
              email: '[email protected]',
              color: '#FFFFFF',
              bgColor: '#8C1D18',
            },
            {
              name: 'Sophia',
              initial: 'SO',
              email: '[email protected]',
              color: '#000000',
              bgColor: '#D0BCFF',
            },
            {
              name: 'Margaret',
              initial: 'MA',
              email: '[email protected]',
              color: '#000000',
              bgColor: '#F2B8B5',
            },
            {
              name: 'Ursula Ann',
              initial: 'UA',
              email: '[email protected]',
              color: '#000000',
              bgColor: '#47ACFB',
            },
            {
              name: 'Laura Grace',
              initial: 'LG',
              email: '[email protected]',
              color: '#000000',
              bgColor: '#FFE088',
            },
            {
              name: 'Albert',
              initial: 'AL',
              email: '[email protected]',
              color: '#FFFFFF',
              bgColor: '#00335B',
            },
            {
              name: 'William',
              initial: 'WA',
              email: '[email protected]',
              color: '#FFFFFF',
              bgColor: '#163E02',
            },
          ],
        };
    };
    methods: {
        created: function () {
          this.rteObj = this.$refs.rteInstance.ej2Instances;
          this.textArea = this.rteObj.contentModule.getEditPanel();
          this.id = this.$refs.rteInstance.ej2Instances.getID() + 'html-preview';
          this.mdsource = document.getElementById('preview-code');
          this.htmlPreview = this.rteObj.element.querySelector(this.id);
          this.previewTextArea =
            this.rteObj.element.querySelector('.e-rte-content');
          this.textArea.onkeyup = (Event) => {
            this.markDownConversion();
          };
          this.mdsource.onclick = (e) => {
            this.fullPreview();
            if (e.currentTarget.classList.contains('e-active')) {
              this.$refs.rteInstance.disableToolbarItem([
                'Bold',
                'Italic',
                'SuperScript',
                'SubScript',
                'StrikeThrough',
                'Formats',
                'Blockquote',
                'OrderedList',
                'UnorderedList',
                'CreateLink',
                'Image',
                'CreateTable',
              ]);
            } else {
              this.$refs.rteInstance.enableToolbarItem([
                'Bold',
                'Italic',
                'SuperScript',
                'SubScript',
                'StrikeThrough',
                'Formats',
                'Blockquote',
                'OrderedList',
                'UnorderedList',
                'CreateLink',
                'Image',
                'CreateTable',
              ]);
            }
          };
        },
      markDownConversion: function () {
        if (this.mdsource.classList.contains('e-active')) {
          this.htmlPreview.innerHTML = marked(this.textArea.value);
        }
      },
      fullPreview: function () {
        if (this.mdsource.classList.contains('e-active')) {
          this.mdsource.classList.remove('e-active');
          this.textArea.style.display = 'block';
          this.htmlPreview.style.display = 'none';
          this.previewTextArea.style.overflow = 'hidden';
        } else {
          this.mdsource.classList.add('e-active');
          if (!this.htmlPreview) {
            this.htmlPreview = document.createElement('div');
            this.htmlPreview.setAttribute('class', 'e-content e-pre-source');
            this.htmlPreview.setAttribute('id', this.id);
            this.textArea.parentNode.appendChild(this.htmlPreview);
            this.previewTextArea.style.overflow = 'auto';
          }
          if (this.previewTextArea.style.overflow === 'hidden') {
            this.previewTextArea.style.overflow = 'auto';
          }
          this.textArea.style.display = 'none';
          this.htmlPreview.style.display = 'block';
          this.htmlPreview.innerHTML = marked(this.textArea.value);
          this.mdsource.parentElement.title = 'Code View';
        }
      },
    },
    provide:{
        richtexteditor:[Toolbar, Link, Image,Table, MarkdownEditor]
    }
}
</script>

<style>
@import "../../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-inputs/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-lists/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-buttons/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-vue-richtexteditor/styles/tailwind3.css";
</style>

Syncfusion AI Assistant

How can I help you?

Mention Support in Angular Markdown Editor Component

29 Aug 202516 minutes to read

By integrating the Mention component with the Markdown Editor, users can effortlessly mention or tag other users or objects from a suggested list. This eliminates the need to manually type out names or identifying information, improving both efficiency and accuracy.

Enabling mention in Markdown Editor

To enable the Mention functionality within the Markdown Editor, set the target property of the Mention component to the ID of the textarea element inside the editor. When specifying the target, ensure that you append the suffix _editable-content to the ID. This configuration allows users to mention or tag others from the suggested list while editing text.

When a user types the @ symbol followed by a character, the Markdown Editor displays a list of suggestions. Users can select an item from the list by either clicking on it or typing the desired name.

Configuring mention properties

The Syncfusion Mention component provides several customizable properties to enhance the tagging experience:

  • allowSpaces - Allow to continue search action if user enter space after mention character while searching.
  • suggestionCount - Defines the maximum number of items displayed in the suggestion list.
  • itemTemplate - Customizes the appearance of items in the suggestion list.

Example: Implementing mention in markdown editor

The following example demonstrates how to enable Mention support in the Angular Markdown Editor.

import { enableRipple } from '@syncfusion/ej2-base';
import { Component, ViewChild } from '@angular/core';
import { NgStyle } from '@angular/common';
import {
  RichTextEditorComponent,
  ToolbarService,
  TableService,
  EditorMode,
  RichTextEditorModule,
  ContentRender,  
  LinkService,
  ImageService,
  MarkdownEditorService,
} from '@syncfusion/ej2-angular-richtexteditor';
import { MarkdownFormatter } from '@syncfusion/ej2-angular-richtexteditor';
import { createElement } from '@syncfusion/ej2-base';
import { marked } from 'marked';
import { ToolbarModule } from '@syncfusion/ej2-angular-navigations';
import {
    MentionComponent,
    MentionModule,
  } from '@syncfusion/ej2-angular-dropdowns';
enableRipple(true);

@Component({
    imports: [RichTextEditorModule, MentionModule, NgStyle],
    standalone: true,
    selector: 'app-root',
    template: `<ejs-richtexteditor [value]='value' id='mdDefault' #mdDefault height='250px' [formatter]='formatter'
    [toolbarSettings]='tools' [editorMode]='mode' (created)='onCreate()'>
</ejs-richtexteditor>
<ejs-mention #editorMention id='editorMention' [dataSource]='emailData' [fields]='fields' [allowSpaces]="true" 
popupWidth='250px' popupHeight='200px' sortOrder='Ascending' target='#mdDefault_editable-content' >
<ng-template #displayTemplate let-data>
    [&commat;](mailto:)
</ng-template>

<ng-template #itemTemplate let-data>
<div class="editor-mention-item-template">
    <div class="em-header">
        <div class="em-avatar" [ngStyle]="{ 'background-color': data.bgColor, 'color': data.color} ">
            <div class="em-initial"></div>
        </div>
    </div>
    <div class="em-content">
      <div class="em-name"></div>
      <div class="em-email"></div>
    </div>
  </div>
</ng-template>
</ejs-mention>`,
    providers: [ToolbarService, LinkService, ImageService, MarkdownEditorService, TableService]
})

export class AppComponent {
    @ViewChild('mdDefault')
    public rteObj!: RichTextEditorComponent;
  
    @ViewChild('editorMention')
    public mention!: MentionComponent;
  
    public emailData: { [key: string]: Object }[] = [
      {
        name: 'Selma Rose',
        initial: 'SR',
        email: '[email protected]',
        color: '#FAFDFF',
        bgColor: '#01579B',
      },
      {
        name: 'Maria',
        initial: 'MA',
        email: '[email protected]',
        color: '#004378',
        bgColor: '#ADDBFF',
      },
      {
        name: 'Russo Kay',
        initial: 'RK',
        email: '[email protected]',
        color: '#F9DEDC',
        bgColor: '#8C1D18',
      },
      {
        name: 'Robert',
        initial: 'RO',
        email: '[email protected]',
        color: '#FFD6F7',
        bgColor: '#37003A',
      },
      {
        name: 'Camden Kate',
        initial: 'CK',
        email: '[email protected]',
        color: '#FFFFFF',
        bgColor: '#464ECF',
      },
      {
        name: 'Garth',
        initial: 'GA',
        email: '[email protected]',
        color: '#FFFFFF',
        bgColor: '#008861',
      },
      {
        name: 'Andrew James',
        initial: 'AJ',
        email: '[email protected]',
        color: '#FFFFFF',
        bgColor: '#53CA17',
      },
      {
        name: 'Olivia',
        initial: 'OL',
        email: '[email protected]',
        color: '#FFFFFF',
        bgColor: '#8C1D18',
      },
      {
        name: 'Sophia',
        initial: 'SO',
        email: '[email protected]',
        color: '#000000',
        bgColor: '#D0BCFF',
      },
      {
        name: 'Margaret',
        initial: 'MA',
        email: '[email protected]',
        color: '#000000',
        bgColor: '#F2B8B5',
      },
      {
        name: 'Ursula Ann',
        initial: 'UA',
        email: '[email protected]',
        color: '#000000',
        bgColor: '#47ACFB',
      },
      {
        name: 'Laura Grace',
        initial: 'LG',
        email: '[email protected]',
        color: '#000000',
        bgColor: '#FFE088',
      },
      {
        name: 'Albert',
        initial: 'AL',
        email: '[email protected]',
        color: '#FFFFFF',
        bgColor: '#00335B',
      },
      {
        name: 'William',
        initial: 'WA',
        email: '[email protected]',
        color: '#FFFFFF',
        bgColor: '#163E02',
      },
    ];
  
    public fields: Object = { text: 'name' };
    public textArea!: HTMLTextAreaElement;
    public mdsource!: HTMLElement;
    public value: string =
      'Hello [@Maria](mailto:[email protected])\n\nWelcome to the mention integration with markdown editor demo. Type @ character and tag user from the suggestion list.';
    public placeholder: string = 'Enter the text here...';
    public tools: ToolbarModule = {
      items: [
        'Bold',
        'Italic',
        'StrikeThrough',
        '|',
        'Formats',
        'Blockquote',
        'OrderedList',
        'UnorderedList',
        'SuperScript',
        'SubScript',
        '|',
        'CreateTable',
        'CreateLink',
        'Image',
        '|',
        {
          tooltipText: 'Preview',
          template:
            '<button id="preview-code" class="e-tbar-btn e-control e-btn e-icon-btn" aria-label="Preview Code">' +
            '<span class="e-btn-icon e-md-preview e-icons"></span></button>',
        },
        '|',
        'Undo',
        'Redo',
      ],
    };
  
    public formatter: MarkdownFormatter = new MarkdownFormatter({
      listTags: { OL: '1., 2., 3.' },
    });
    public mode: EditorMode = 'Markdown';
  
    public onCreate(): void {
      this.textArea = (
        this.rteObj!.contentModule as ContentRender
      ).getEditPanel() as HTMLTextAreaElement;
      this.textArea.addEventListener('keyup', () => {
        this.markDownConversion();
      });
      this.mdsource = document.getElementById('preview-code') as HTMLElement;
      this.mdsource?.addEventListener('click', (e: MouseEvent) => {
        this.fullPreview();
      });
    }
    public async markDownConversion(): Promise<void> {
      if (this.mdsource?.classList.contains('e-active')) {
        let id: string = this.rteObj?.getID() + 'html-view';
        let htmlPreview: Element = this.rteObj!.element.querySelector(
          '#' + id
        ) as Element;
        htmlPreview.innerHTML = await marked(
          (
            (
              this.rteObj!.contentModule as ContentRender
            ).getEditPanel() as HTMLTextAreaElement
          ).value
        );
      }
    }
    public async fullPreview(): Promise<void> {
      let id: string = this.rteObj!.getID() + 'html-preview';
      let htmlPreview: HTMLElement = this.rteObj!.element.querySelector(
        '#' + id
      ) as HTMLElement;
      if (this.mdsource!.classList.contains('e-active')) {
        this.mdsource!.classList.remove('e-active');
        this.textArea!.style.display = 'block';
        htmlPreview.style.display = 'none';
      } else {
        this.mdsource!.classList.add('e-active');
        if (!htmlPreview) {
          htmlPreview = createElement('div', {
            className: 'e-content e-pre-source',
          });
          htmlPreview.id = id;
          this.textArea!.parentNode!.appendChild(htmlPreview);
        }
        this.textArea!.style.display = 'none';
        htmlPreview.style.display = 'block';
        htmlPreview.innerHTML = await marked(
          (
            (
              this.rteObj!.contentModule as ContentRender
            ).getEditPanel() as HTMLTextAreaElement
          ).value
        );
        this.mdsource!.parentElement!.title = 'Code View';
      }
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));